Number String (hdu 4055)

The signature of a permutation is a string that is computed as follows: for each pair of consecutive elements of the permutation, write down the letter 'I' (increasing) if the second element is greater than the first one, otherwise write down the letter 'D' (decreasing). For example, the signature of the permutation {3,1,2,7,4,6,5} is "DIIDID". 

Your task is as follows: You are given a string describing the signature of many possible permutations, find out how many permutations satisfy this signature. 

Note: For any positive integer n, a permutation of n elements is a sequence of length n that contains each of the integers 1 through n exactly once. 

Input

Each test case consists of a string of 1 to 1000 characters long, containing only the letters 'I', 'D' or '?', representing a permutation signature. 

Each test case occupies exactly one single line, without leading or trailing spaces. 

Proceed to the end of file. The '?' in these strings can be either 'I' or 'D'. 

Output

For each test case, print the number of permutations satisfying the signature on a single line. In case the result is too large, print the remainder modulo 1000000007. 

Sample Input

II
ID
DI
DD
?D
??

Sample Output

1
2
2
1
3
6

Hint

Permutation {1,2,3} has signature "II".
Permutations {1,3,2} and {2,3,1} have signature "ID".
Permutations {3,1,2} and {2,1,3} have signature "DI".
Permutation {3,2,1} has signature "DD".
"?D" can be either "ID" or "DD".
"??" gives all possible permutations of length 3.

题解:其实第n个选择和第n-1个选择是一样的,比如下一位是“D”,我们前面排好了2 1 3,现在所求为dp[4][2],我们的方法是把数列里面大于等于2的全部加1,小于2的不变,再把2排到最后,这样并不会改变前面排好序列的大小关系。那么我们得到的序列就是3 1 4 2。如果第n个是"I",我们前面排好了2 1 3,就将4加到最后。设dp[i][j]为数列第i个数字为j。 
如果此位和前一位的关系为I,即前一位小于此位,那么前一位可能是任意小于j的数字。所以dp[i][j]=dp[i-1][j-1]+dp[i-1][j-2]+…+dp[i-1][1]。 
如果此位和前一位的关系为D,即前一位大于此位,那么前一位可能是任意大于等于j的数字。所以dp[i][j]=dp[i-1][i-1]+dp[i-1][i-2]+…+dp[i-1][j]

代码如下:

#include <iostream>
#include <cstdio>
#include <stdlib.h>
#include <cmath>
#include <cstring>
#include <algorithm>
#include <string.h>
#include <vector>
#include <queue>
#include <stack>
#include <set>
#include <map>
#include <ctime>
#define maxn 10007
#define N 107
#define INF 0x3f3f3f3f
#define PI acos(-1)
#define lowbit(x) (x&(-x))
#define eps 0.000000001
#define mod 1000000007
using namespace std;
typedef long long ll;
long long dp[1005][1005],sum[1005][1005];
char s[1005];
int main()
{
    int n,i,j;
    while(scanf("%s",s+2)>0)
    {
        dp[1][1]=sum[1][1]=1;
        n=strlen(s+2)+1;
        for(i=2; i<=n; i++)
        {
            for(j=1; j<=n; j++)
            {
                if(s[i]=='I') 
                    dp[i][j]=sum[i-1][j-1];
                else if(s[i]=='D') 
                    dp[i][j]=sum[i-1][i-1]-sum[i-1][j-1];
                else 
                    dp[i][j]=sum[i-1][i-1];
                sum[i][j]=(sum[i][j-1]+dp[i][j])%mod;
            }
        }
        printf("%lld\n",(sum[n][n]+mod)%mod);
    }
    return 0;
}

猜你喜欢

转载自blog.csdn.net/baiyi_destroyer/article/details/81108541
今日推荐